%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                                    PSG Type    PSG Object                           Location in Problem Statement                      Class
%matrix_h_data                             data        matrix_h                             cdar_dev(parameter_alpha, matrix_h)                double
%matrix_h_vars                             vars        matrix_h                             cdar_dev(parameter_alpha, matrix_h)                cell
%matrix_average_annualized_returns_data    data        matrix_average_annualized_returns    linear(matrix_average_annualized_returns)          double
%matrix_average_annualized_returns_vars    vars        matrix_average_annualized_returns    linear(matrix_average_annualized_returns)          cell
%parameter_bound_data                      data        parameter_bound                      Constraint: <= parameter_bound                     double
%parameter_alpha_data                      data        parameter_alpha                      cdar_dev(parameter_alpha, matrix_h)                double
%parameter_bound_1_data                    data        parameter_bound_1                    Box: >= parameter_bound_1, <= parameter_bound_2    double
%parameter_bound_2_data                    data        parameter_bound_2                    Box: >= parameter_bound_1, <= parameter_bound_2    double
%parameter_precision_data                  data        parameter_precision                  Solver: precision = parameter_precision            char
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_h_data,matrix_h_vars,matrix_average_annualized_returns_data,matrix_average_annualized_returns_vars,parameter_bound_data,parameter_alpha_data,parameter_bound_1_data,parameter_bound_2_data,parameter_precision_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_h',matrix_h_data,matrix_h_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_average_annualized_returns',matrix_average_annualized_returns_data,matrix_average_annualized_returns_vars,[],[]);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'maximize',...
'  linear(matrix_average_annualized_returns)',...
'Constraint: <= parameter_bound',...
'  cdar_dev(parameter_alpha, matrix_h)',...
'Box: >= parameter_bound_1, <= parameter_bound_2',...
'Solver: precision = parameter_precision',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_precision',parameter_precision_data);
problem_statement = strrep(problem_statement,'parameter_bound_1',num2str(parameter_bound_1_data));
problem_statement = strrep(problem_statement,'parameter_bound_2',num2str(parameter_bound_2_data));
problem_statement = strrep(problem_statement,'parameter_bound',num2str(parameter_bound_data));
problem_statement = strrep(problem_statement,'parameter_alpha',num2str(parameter_alpha_data));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

